package fr.ippon.direct;

import java.io.IOException;
import java.nio.ByteBuffer;

import com.sun.jna.Memory;

/**
 * @author IPPON_NANTES
 * 
 */
public class JavaNativeAccess {

	public static void main(String[] args) throws InterruptedException,
			IOException, ClassNotFoundException {
		int value = 12345;
		int offset = 0;
		int size = 128;

		// on crée un objet mémory
		Memory m = new Memory(1024);
		// on alloue l'espace mémoire
		ByteBuffer buff = m.getByteBuffer(0, size);
		offset = offset + size;
		// On insere l'objet
		buff.putInt(value);
		// RAZ de la position courante du buffer
		buff.flip();

		// On récupère et affiche l'objet
		System.out.println(buff.getInt());

		// On déclare un deuxième buffer
		ByteBuffer buff2 = m.getByteBuffer(offset, size);
		// On insère l'objet
		buff2.putInt(value + 1);
		// RAZ de la position courante du buffer
		buff2.flip();
		// On récupère et affiche l'objet
		System.out.println(buff2.getInt());
		// on libère la mémoire
		m.clear();

		// methode 2
		// on crée un objet mémory
		// et on insère directement les objets
		Memory m2 = new Memory(1024);
		// On insere l'objet
		m2.setInt(offset, value);

		// On récupère et affiche l'objet
		System.out.println(m2.getInt(offset));
		// on libère la mémoire
		m2.clear();

	}

}
