package fr.ippon.direct;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;

import fr.ippon.direct.cache.NativeMemoryCache;


/**
 * @author IPPON_NANTES
 * 
 */
public class LaunchDirect {
	/**
	 * @param args
	 * @throws InterruptedException
	 * @throws IOException
	 * @throws ClassNotFoundException
	 * @throws InvocationTargetException 
	 * @throws IllegalAccessException 
	 * @throws NoSuchMethodException 
	 * @throws IllegalArgumentException 
	 * @throws SecurityException 
	 * @throws SigarException
	 */
	public static void main(String[] args) throws InterruptedException,
			IOException, ClassNotFoundException, SecurityException, IllegalArgumentException, NoSuchMethodException, IllegalAccessException, InvocationTargetException {
		final int NANO_TO_MILLI = 1000000;
		
		long startTime = System.nanoTime();    
		NativeMemoryCache nmc = Load.loadDirect();
		long estimatedTimeTraitement = System.nanoTime() - startTime;
		nmc.print();
		
		System.out.println();
		System.out.println("Direct");
		System.out.println("Temps de traitement (ms) : " + estimatedTimeTraitement / NANO_TO_MILLI);
		TraceMemory.trace();
		nmc.freeBuffer();
	}

}
