package fr.ippon.direct;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;

import fr.ippon.direct.cache.MemoryCache;
import fr.ippon.direct.cache.NativeMemoryCache;
import fr.ippon.direct.cache.NativeMemoryCacheUnSafe;
import fr.ippon.direct.domain.Commune;
import fr.ippon.direct.domain.CommuneExternalizable;


/**
 * @author IPPON_NANTES
 * 
 */
public class Load {
	
	private static String path = "bin/ressource/villes1000hab.csv";
	
	public static MemoryCache loadClassic() throws FileNotFoundException {
		
		MemoryCache mc = new MemoryCache();
		
		String ligne;

		try {

			BufferedReader br = new BufferedReader(new FileReader(path));

			// on ignore la première ligne
			ligne = br.readLine();

			while ((ligne = br.readLine()) != null) {
				String[] s = ligne.split(";");
					long codeCommune = Long.parseLong(s[0]);
					String nomCommune = s[1];
					double latitude = Double.parseDouble(s[2]);
					double longitude = Double.parseDouble(s[3]);
					String codePays = s[4];
					String codeRegion = s[5];
					String codeAdministratif = s[6];
					int population = Integer.parseInt(s[7]);	
					String timeZone = null;
					if (s.length > 8) {
						timeZone = s[8];
					}
					mc.put(codeCommune, new Commune(codeCommune, nomCommune, latitude, longitude,
								codePays, codeRegion, codeAdministratif, population, timeZone));
			}
			br.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return mc;
	}
public static NativeMemoryCacheUnSafe loadUnsafe() throws FileNotFoundException {
		
	NativeMemoryCacheUnSafe mcu = new NativeMemoryCacheUnSafe();
		String ligne;

		try {

			BufferedReader br = new BufferedReader(new FileReader(path));

			// on ignore la première ligne
			ligne = br.readLine();
	
			while ((ligne = br.readLine()) != null) {
				String[] s = ligne.split(";");
					long codeCommune = Long.parseLong(s[0]);
					
					String nomCommune = s[1];
					double latitude = Double.parseDouble(s[2]);
					double longitude = Double.parseDouble(s[3]);
					String codePays = s[4];
					String codeRegion = s[5];
					String codeAdministratif = s[6];
					int population = Integer.parseInt(s[7]);	
					String timeZone = null;
					if (s.length > 8) {
						timeZone = s[8];
					}

					mcu.put(codeCommune, new Commune(codeCommune, nomCommune, latitude, longitude,
							codePays, codeRegion, codeAdministratif, population, timeZone));
			}
			
			br.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return mcu;
	}
	
	public static NativeMemoryCache loadDirect() throws FileNotFoundException {
		NativeMemoryCache nmc = new NativeMemoryCache();
		String ligne;

		try {

			BufferedReader br = new BufferedReader(new FileReader(path));

			// on ignore la première ligne
			ligne = br.readLine();

			while ((ligne = br.readLine()) != null) {
				String[] s = ligne.split(";");
				long codeCommune = Long.parseLong(s[0]);
				String nomCommune = s[1];
				double latitude = Double.parseDouble(s[2]);
				double longitude = Double.parseDouble(s[3]);
				String codePays = s[4];;
				String codeRegion = s[5];;
				String codeAdministratif = s[6];
				int population = Integer.parseInt(s[7]);	
				String timeZone = null;
				if (s.length > 8) {
					timeZone = s[8];
				}
					
				nmc.put(codeCommune, new Commune(codeCommune, nomCommune, latitude, longitude,
							codePays, codeRegion, codeAdministratif, population, timeZone));
			}
			br.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return nmc;
	}
	public static NativeMemoryCache loadDirectExternalizable() throws FileNotFoundException {
		NativeMemoryCache nmch = new NativeMemoryCache();
		String ligne;

		try {

			BufferedReader br = new BufferedReader(new FileReader(path));

			// on ignore la première ligne
			ligne = br.readLine();

			while ((ligne = br.readLine()) != null) {
				String[] s = ligne.split(";");
				long codeCommune = Long.parseLong(s[0]);
				String nomCommune = s[1];
				double latitude = Double.parseDouble(s[2]);
				double longitude = Double.parseDouble(s[3]);
				String codePays = s[4];
				String codeRegion = s[5];
				String codeAdministratif = s[6];
				int population = Integer.parseInt(s[7]);	
				String timeZone = null;
				if (s.length > 8) {
					timeZone = s[8];
				}
					nmch.put(codeCommune, new CommuneExternalizable(codeCommune, nomCommune, latitude, longitude,
							codePays, codeRegion, codeAdministratif, population, timeZone));
			}
			br.close();

		} catch (Exception e) {
			e.printStackTrace();
		}
		return nmch;
	}
	
}
