package fr.ippon.direct.domain;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

/**
 * @author IPPON_NANTES
 * 
 */
public class Commune implements Serializable {
	private static final long serialVersionUID = -2785916179945260524L;
	
	private long codeCommune;
	private String nomCommune;
	private double latitude;
	private double longitude;
	private String codePays;
	private String codeRegion;
	private String codeAdministratif;
	private int population;	
	private String timeZone;
	

	public Commune(long codeCommune,String nomCommune, double latitude, double longitude,
			String codePays, String codeRegion, String codeAdministratif,
			int population, String timeZone) {
		super();
		this.nomCommune = nomCommune;
		this.latitude = latitude;
		this.longitude = longitude;
		this.codePays = codePays;
		this.codeRegion = codeRegion;
		this.codeAdministratif = codeAdministratif;
		this.population = population;
		this.timeZone = timeZone;
		this.codeCommune = codeCommune;
	}
	

	@Override
	public String toString() {
		return "Commune [nom=" + nomCommune + ", latitude=" + latitude
				+ ", longitude=" + longitude + ", Pays=" + codePays
				+ ", population=" + population
				+ ", timeZone=" + timeZone + "]";
	}

	public long getCodeCommune() {
		return codeCommune;
	}

	public void setCodeCommune(long codeCommune) {
		this.codeCommune = codeCommune;
	}

	public String getNomCommune() {
		return nomCommune;
	}

	public void setNomCommune(String nomCommune) {
		this.nomCommune = nomCommune;
	}

	public double getLatitude() {
		return latitude;
	}

	public void setLatitude(double latitude) {
		this.latitude = latitude;
	}

	public double getLongitude() {
		return longitude;
	}

	public void setLongitude(double longitude) {
		this.longitude = longitude;
	}

	public String getCodePays() {
		return codePays;
	}

	public void setCodePays(String codePays) {
		this.codePays = codePays;
	}

	public String getCodeRegion() {
		return codeRegion;
	}

	public void setCodeRegion(String codeRegion) {
		this.codeRegion = codeRegion;
	}

	public String getCodeAdministratif() {
		return codeAdministratif;
	}

	public void setCodeAdministratif(String codeAdministratif) {
		this.codeAdministratif = codeAdministratif;
	}

	public int getPopulation() {
		return population;
	}

	public void setPopulation(int population) {
		this.population = population;
	}

	public String getTimeZone() {
		return timeZone;
	}

	public void setTimeZone(String timeZone) {
		this.timeZone = timeZone;
	}
		
	public byte[] getBytes() throws java.io.IOException{
	      ByteArrayOutputStream bos = new ByteArrayOutputStream(); 
	      ObjectOutputStream oos = new ObjectOutputStream(bos); 
	      oos.writeObject(this);
	      oos.close(); 
	      return bos.toByteArray();
	  }
	
	public static Commune fromBytes(byte[] source) throws java.io.IOException, ClassNotFoundException{
		ByteArrayInputStream bis = new ByteArrayInputStream(source);
		ObjectInputStream ois = new ObjectInputStream(bis);
		Commune obj = (Commune) ois.readObject();
		ois.close();
		return obj;
	  }
	
		
}


