package fr.ippon.direct.domain;

import java.io.Externalizable;
import java.io.IOException;
import java.io.ObjectInput;
import java.io.ObjectOutput;

/**
 * @author IPPON_NANTES
 * 
 */
public class CommuneExternalizable implements Externalizable {
	private static final long serialVersionUID = 6469735582122573697L;
	
	private long codeCommune;
	private String nomCommune;
	private double latitude;
	private double longitude;
	private String codePays;
	private String codeRegion;
	private String codeAdministratif;
	private int population;	
	private String timeZone;
	

	public CommuneExternalizable(long codeCommune,String nomCommune, double latitude, double longitude,
			String codePays, String codeRegion, String codeAdministratif,
			int population, String timeZone) {
		super();
		this.codeCommune = codeCommune;
		this.nomCommune = nomCommune;
		this.latitude = latitude;
		this.longitude = longitude;
		this.codePays = codePays;
		this.codeRegion = codeRegion;
		this.codeAdministratif = codeAdministratif;
		this.population = population;
		this.timeZone = timeZone;
	}
	
	// utile pour la sérialisation
	public CommuneExternalizable() {
		
	}
	
	@Override
	public String toString() {
		return "Commune [nom=" + nomCommune + ", latitude=" + latitude
				+ ", longitude=" + longitude + ", Pays=" + codePays
				+ ", population=" + population
				+ ", timeZone=" + timeZone + "]";
	}

	public long getCodeCommune() {
		return codeCommune;
	}

	public void setCodeCommune(long codeCommune) {
		this.codeCommune = codeCommune;
	}

	public String getNomCommune() {
		return nomCommune;
	}

	public void setNomCommune(String nomCommune) {
		this.nomCommune = nomCommune;
	}

	public double getLatitude() {
		return latitude;
	}

	public void setLatitude(double latitude) {
		this.latitude = latitude;
	}

	public double getLongitude() {
		return longitude;
	}

	public void setLongitude(double longitude) {
		this.longitude = longitude;
	}

	public String getCodePays() {
		return codePays;
	}

	public void setCodePays(String codePays) {
		this.codePays = codePays;
	}

	public String getCodeRegion() {
		return codeRegion;
	}

	public void setCodeRegion(String codeRegion) {
		this.codeRegion = codeRegion;
	}

	public String getCodeAdministratif() {
		return codeAdministratif;
	}

	public void setCodeAdministratif(String codeAdministratif) {
		this.codeAdministratif = codeAdministratif;
	}

	public int getPopulation() {
		return population;
	}

	public void setPopulation(int population) {
		this.population = population;
	}

	public String getTimeZone() {
		return timeZone;
	}

	public void setTimeZone(String timeZone) {
		this.timeZone = timeZone;
	}


	@Override
	public void writeExternal(ObjectOutput out) throws IOException {
		out.writeLong(this.codeCommune);
		out.writeObject(this.nomCommune);
		out.writeDouble(this.latitude);
		out.writeDouble(this.longitude);
		out.writeObject(this.codePays);
		out.writeObject(this.codeRegion);
		out.writeObject(this.codeAdministratif);
		out.writeInt(this.population);
		out.writeObject(this.timeZone);

		
	}

	@Override
	public void readExternal(ObjectInput in) throws IOException,
			ClassNotFoundException {
		this.codeCommune = (long) in.readLong();
		this.nomCommune = (String) in.readObject();
		this.latitude = (double) in.readDouble();
		this.longitude = (double) in.readDouble();
		this.codePays = (String) in.readObject();
		this.codeRegion = (String) in.readObject();
		this.codeAdministratif = (String) in.readObject();
		this.population = (int) in.readInt();
		this.timeZone = (String) in.readObject();
	}
	
		
}


